<?php

/*
================================================================
	DC Gallery
================================================================
	File:			ext.dc_gallery_ext.php
----------------------------------------------------------------
	Version:		1.0
----------------------------------------------------------------
	Compatibility:	EE 1.6.7
----------------------------------------------------------------
	Updated:		2010-04-03
================================================================
*/

/** ----------------------------------------
/**	Begin class
/** ----------------------------------------*/

class dc_gallery_ext
{
	var $name			= "DC Gallery";
	var $version		= "1.0 Alpha 2";
	var $description	= "Adds a gallery tab in the EE Publish/Edit panels.";
	var $settings_exist	= "n";
	var $docs_url		= "http://denik.od.ua/";
	var $label			= '';
	
	var $settings		= array();
	
    /** ----------------------------------------
    /**	Constructor
    /** ----------------------------------------*/

    function dc_gallery_ext($settings = '')
    {
    	global $PREFS, $LANG;
    	
    	$LANG->fetch_language_file('dc_gallery');
		$this->settings = $settings;
		if( isset($this->settings[$PREFS->ini('site_id')]) ) $this->settings = $this->settings[$PREFS->ini('site_id')];
	}
	
	/**	End constructor */
	
	/** Get Config */
	function conf($key)
	{
		return isset($this->settings[$key])?$this->settings[$key]:FALSE;
	}
	
    /** ----------------------------------------
    /**	Activate
    /** ----------------------------------------*/

	function activate_extension()
	{
		global $DB;

		if( ! class_exists('Dc_gallery_CP') )
		{
			require PATH_MOD.'dc_gallery/mcp.dc_gallery.php';
			Dc_gallery_CP::Dc_gallery_module_install();
		}
	}
	
	/**	End activate */
	
	
	/** ----------------------------------------
	/**	Disable
	/** ----------------------------------------*/

	function disable_extension()
	{
		global $DB;
		
		/*if( ! class_exists('Dc_gallery_CP') )
		{
			require PATH_MOD.'dc_gallery/mcp.dc_gallery.php';
			Dc_gallery_CP::Dc_gallery_module_deinstall();
		}*/
	}
	
	/**	End disable */
	


	/** ----------------------------------------
	/**	Set form enctype
	/** ----------------------------------------*/

	function set_form_enctype( $out )
	{
		global $EXT;
		
		$EXT->end_script = FALSE;
		$out = ( $EXT->last_call!=='' ) ? $EXT->last_call: $out;
		
		/** ----------------------------------------
		// Make Publish Table multipart/form-data
		/** ----------------------------------------*/
		if(preg_match("/name=.entryform./", $out, $matches))
		{
			// Check to see if we already have the multipart stuff in the tag, add it if we don't
			if(! preg_match("/enctype=\"multipart\/form-data\"/", $matches[0]) ) {
				$out = str_replace($matches[0], $matches[0] . " enctype=\"multipart/form-data\"", $out);
			}
		}

		return $out;
	}
	
	/**	End set form enctype */
	
	
	/** ----------------------------------------
	/**	Gallery Extended tab
	/** ----------------------------------------*/

	function gallery_tab( $publish_tabs, $weblog_id, $entry_id )
	{
		global $EXT, $LANG, $IN;
		
		$EXT->end_script = FALSE;
		
		$publish_tabs	= ( is_array( $EXT->last_call ) === TRUE ) ? $EXT->last_call: $publish_tabs;
		
		// Enable for this weblog ?
		if( ! $this->conf('weblogs') || ! in_array($IN->GBL('weblog_id'), $this->conf('weblogs')) ) return $publish_tabs;
		
		
		/** ----------------------------------------
		// Add tag tab to tab array
		/** ----------------------------------------*/
		$this->label = $this->conf('label');
		$publish_tabs['dc_gallery']	= htmlspecialchars(( $this->label != '' ) ? $this->label:$LANG->line('images'));

		/** ----------------------------------------
		// Return tabs array
		/** ----------------------------------------*/

		return $publish_tabs;
	}
	
	/**	End gallery extended tab */
	
	
	/** ----------------------------------------
	/**	Gallery Extended tab block
	/** ----------------------------------------*/

	function gallery_tab_block( $weblog_id )
	{
		global $EXT, $DSP, $IN, $LANG, $DB;
		
		$EXT->end_script = FALSE;
		
		$r	= ( $EXT->last_call != '' ) ? $EXT->last_call: '';
		
		// Enable for this weblog ?
		if( ! $this->conf('weblogs') || ! in_array($IN->GBL('weblog_id'), $this->conf('weblogs')) ) return $r;
		
		/** ----------------------------------------
		// Instantiate
		/** ----------------------------------------*/
		
		$this->gallery_header();
//	echo 	$IN->GBL('entry_id', 'GET');
		$r .= NL."<div id='blockdc_gallery' style='display:none;'>";
		$r .= NL.'<div class="publishTabWrapper">';
		$r .= NL.'<div class="publishBox">';
		$r .= NL.'<div class="publishInnerPad">';
		$r .= NL.'<div class="dc_gallery clearfix">';

		if( $IN->GBL('C', 'GET') != 'edit' )
		{
			$r .= NL.$LANG->line('on_edit_only');
		}
		else
		{
			$r .= '<div class="menu"><a id="dc_gallery_sortable" href="javascript:void(0)">'.$LANG->line('m_sort').'</a>';
			$r .= ' | <a id="dc_gallery_empty_cats" href="javascript:void(0)">'.$LANG->line('m_empty_cats').'</a></div>';
			
			/** Form add images */
			$param = "";
			if( $this->conf("cat_groups") && sizeof($this->conf("cat_groups"))>0 && $this->conf("cat_groups") != array(0) )
			{
				$param = $DSP->input_select_header('dc_gallery_cat[]')."<option value=''>".$LANG->line('category')."</option><option value=''>- -</option>";
				if ( ! class_exists('Publish'))
				{
					require PATH_CP.'cp.publish'.EXT;
				}
				$dc_gall_PUB = new Publish();
				foreach( $this->conf("cat_groups") as $group )
				{
					if(isset($c)&&$c=='1') $param .= "<option value=''>- -</option>";
					$c = '1';
					$dc_gall_PUB->categories = Array();
					$dc_gall_PUB->category_tree($group);
					for($i=1; $i<count($dc_gall_PUB->categories)-1;$i++)
					{
						$param .= $dc_gall_PUB->categories[$i];
					}
				}
				$param .= $DSP->input_select_footer().' &nbsp; ';
			}
			$item = "<div class='item'>$param<input type='file' name='dc_gallery_image[]' size='32' onchange='javascript:dc_gallery_item_change(this);' /></div>";
			$item_more = "<div class='item'>$param<input type='file' name='dc_gallery_image[]' size='32' onchange='javascript:dc_gallery_item_change(this);' /> | <a href='javascript:void(0)' onClick='javascript:dc_gallery_form_del(this)'>Delete it</a></div>";
			$r .= '<div class="clearfix"><div class="form_add">';
			$r .= $item;
			$r .= "<div class='more'></div><div id='dc_gallery_form_item' style='display:none;'>$item_more</div>";
			$r .= '<div class="instr">'.$LANG->line('form_add_instr').'</div></div></div>';
			
			// Upload URL
			$url = $this->conf('upload_url');
			$url = str_replace(LD.'weblog_id'.RD, $IN->GBL('weblog_id'), $url); // {weblog_id}
			$url = str_replace(LD.'entry_id'.RD, $IN->GBL('entry_id'), $url); // {entry_id}
			$blog_name = $DB->query("SELECT `blog_name` FROM `exp_weblogs` WHERE `weblog_id`='".$IN->GBL('weblog_id')."' LIMIT 0,1");
			$url = str_replace(LD.'blog_name'.RD, $blog_name->row['blog_name'], $url); // {blog_name}

			/** Image manager */
			$img = $DB->query("SELECT g.`image_id`, g.`cat_id`,c.`cat_name`, g.`filename`, g.`filename_medium`, g.`filename_thumb`, g.`order`, g.`wh_param` FROM exp_dc_gallery as g LEFT JOIN exp_categories as c ON c.`cat_id`=g.`cat_id` WHERE g.`entry_id`='".$IN->GBL('entry_id')."' ORDER BY c.`cat_name` ASC, g.`order` ASC");

			//   
			$imgs = array();
			foreach( $img->result as $row )
				$imgs[$row['cat_id']][] = $row;
			
			$cats = array();
			$r_cat = "";
			$r_cat0 = "";
			foreach( $imgs as $row_cat )
			{
				$cats[] = $row_cat[0]['cat_id'];
				$cat_name = ( $row_cat[0]['cat_name']!="" )?$row_cat[0]['cat_name']:$LANG->line('no_category');
				$r_cat .= "<h1 class='c_{$row_cat[0]['cat_id']}'>$cat_name</h1><ul class='categ clearfix' categ='{$row_cat[0]['cat_id']}'>";
				foreach( $row_cat as $row )
				{
					$wh_param = ($row["wh_param"]!="")? unserialize($row["wh_param"]) : '';
					$w = 110;
					$h = 83;
					if( $row["filename_medium"]!="" ) $src = $url.$row["filename_medium"];
					elseif( $row["filename_thumb"]!="" ) $src = $url.$row["filename_thumb"];
					else $src = $url.$row["filename"];
					$r_cat .= "<li img_id='{$row["image_id"]}'>";
					$r_cat .= "<div class='img'><img src='$src' width='{$w}px' height='{$h}px' border='0' /></div>";
					$r_cat .= "<div class='sub'><a href='javascript:void(0)' class='delete'><img src='".PATH_CP_IMG."dc_gallery/delete.gif' border='0' /></a> <a onclick=\"window.open('".BASE.AMP.'C=modules'.AMP.'M=Dc_gallery'.AMP.'P=modify_s'.AMP."Z=1&id={$row["image_id"]}', '_blank', 'width=550,height=480,scrollbars=yes,status=yes,screenx=0,screeny=0,resizable=yes'); return false;\" href='javascript:void(0)' class='modify'><img src='".PATH_CP_IMG."dc_gallery/modify.gif' border='0' /></a> <span class='move'><img src='".PATH_CP_IMG."dc_gallery/move.gif' border='0' /> Move</span></div>";
					$r_cat .= "</li>";
				}
				$r_cat .= "<div class='sortableInputs'> </div>"; // For sortable inputs
				$r_cat .= "</ul>";
				
				if( $row_cat[0]['cat_id'] == 0 )
				{
					$r_cat0 = $r_cat;
				}
				else $r .= $r_cat;
				$r_cat = "";
			}
			$r .= $r_cat0;
			
			// Empty categories
			if( $this->conf("cat_groups") && sizeof($this->conf("cat_groups"))>0 && $this->conf("cat_groups") != array(0) )
			{
				$cats_res = $DB->query("SELECT `cat_id`, `cat_name` FROM `exp_categories` WHERE `cat_id` NOT IN ('".implode("','", $cats)."') AND `group_id` IN ('".implode("','",$this->conf("cat_groups"))."')");
				foreach( $cats_res->result as $row )
					$r .= "<h1 style='display:none;' class='c_{$row['cat_id']}'>{$row['cat_name']}</h1><ul style='display:none;' class='categ clearfix' categ='{$row['cat_id']}'><div class='sortableInputs'> </div></ul>";
				if( ! in_array(0,$cats) ) $r .= "<h1 style='display:none;' class='c_0'>".$LANG->line('no_category')."</h1><ul style='display:none;' class='categ clearfix' categ='0'><div class='sortableInputs'> </div></ul>";
			}
			
			$r .= "<div class='hiddenFields'> </div>"; // For others hidden fields
		}
		
		$r .= NL.'</div></div></div></div></div>';
		
		return $r;
	}
	
	function gallery_header()
	{
		global $PREFS, $DSP, $LANG;
		ob_start();
		?>
		<style type="text/css">
		.clearfix:after {content: "."; display: block; height: 0; clear: both; visibility: hidden;}
			.dc_gallery {margin: 0 5px 0 0;}
			.dc_gallery .menu {font-size: 14px; background-color: #F0F2FF; padding: 6px 10px;}
			.dc_gallery .menu a {color: #60625F;}
			.dc_gallery .menu a:hover {text-decoration: underline;}
			.dc_gallery .form_add {background-color: #FDFDFD; padding: 0px 20px; float:left; font-size: 13px;}
			.dc_gallery .form_add .instr {font-size: 11px; color: #60625F; padding:10px 0;}
			.dc_gallery .form_add .item {padding:10px 0; border-bottom: 1px solid #dfdfdf;}
			.dc_gallery .form_add select {width: 150px; border:1px solid #B3B9C3; font-size: 13px;}
			.dc_gallery .form_add input {font-size: 13px;}
			.dc_gallery h1 {font-size: 14px; color: #808080; border:1px solid #DFDFDF; border-bottom: none; background-color: #FDFDFD; margin: 5px 0 0 0; padding: 10px 0 0 10px;}
			.dc_gallery .categ {background-color: #FDFDFD; border:1px solid #DFDFDF; border-top: none; padding: 10px; margin: 0;}
			.dc_gallery .categ li {float:left; width:112px; height:105px; display:inline; list-style-type: none; padding:3px; margin:0 5px 5px 0; border: 1px solid #BDBDBD; color:#7F8180; background-color: #FDFBE4;}
			.dc_gallery .categ li.ui-selected {background-color: #F39814;}
			.dc_gallery .categ li.ui-state-highlight {width: 15px; background-color: #FCE8E8;}
			.dc_gallery .categ li.ui-state-highlight * {display:none;}
			.dc_gallery .categ li .img {border: 1px solid #AAAAAA; width: 110px; height: 83px; overflow: hidden;}
			.dc_gallery .categ li .sub {padding: 4px 4px 0 4px;}
			.dc_gallery .categ li .delete {float: right;}
			.dc_gallery .categ li .modify {float: right; margin-right: 5px;}
			.dc_gallery .categ li .move {cursor:move;}
			.dc_gallery .categ li .move img {vertical-align: middle;}
			.dc_gallery .sortableInputs {display: none;}
		</style>
		<!--[if IE]><style type="text/css">
		.clearfix {display: inline-block;}
		</style><![endif]-->
		<?php
		$buffer = ob_get_contents();
		ob_end_clean();

		$buffer = str_replace('{THEME_FOLDER}', $PREFS->ini('theme_folder_url'), $buffer);
		
		$del_foto = $LANG->line('delete_foto');
		$DSP->extra_header .= $buffer;
		$DSP->extra_header .= <<<EOF
		<script type="text/javascript">
		$(document).ready(function(){
		$("#dc_gallery").click(function(){
			// sortable
			$("#dc_gallery_sortable").click(function(){
				$(".dc_gallery .categ").sortable({
					opacity: 0.5,
					connectWith: '.dc_gallery .categ',
					items : 'li',
					placeholder: 'ui-state-highlight',
	        		handle : '.move',
	        		revert: true,
	        		'update': function (event, ui) {
	        			var categ = $(this).attr('categ');
	        			var items = $(this).find("li");
	        			var i = 0;
	        			var inputs = '';
	
	        			while( items[i] )
	        			{
	        				inputs += "<input type='hidden' name='dc_galley_sort["+categ+"][]' value='"+$(items[i]).attr('img_id')+"' />";
	        				i++;
	        			}
	        			
	        			$(this).children(".sortableInputs").html(inputs);
	    			}
				}).disableSelection();
				$(this).css({fontWeight:'bold'});
			});
			$(".dc_gallery .delete").click(function(){
				if( confirm('$del_foto') )
				{
					$(".dc_gallery .hiddenFields").append("<input type='hidden' name='dc_gallery_delete[]' value='"+$(this).parents('li').attr('img_id')+"' />");
					$(this).parents('li').hide('slow', function(){ $(this).remove(); });
				}
			});
			var dc_gallery_empty_cats = false;
			$("#dc_gallery_empty_cats").click(function(){
				var cats = $(".dc_gallery .categ");
				var i = 0;
				while( cats[i] )
				{
					if( $(cats[i]).html().length < 100 ) {
						if( dc_gallery_empty_cats ) {
							$(cats[i]).hide('slow');
							$(".dc_gallery .c_"+$(cats[i]).attr('categ')).hide('slow');
						} else {
							$(cats[i]).show('slow');
							$(".dc_gallery .c_"+$(cats[i]).attr('categ')).show('slow');
						}
					}
					i++;
				}
				if( dc_gallery_empty_cats ) dc_gallery_empty_cats = false; else dc_gallery_empty_cats = true;
			});
		});
		});
		function dc_gallery_form_del(obj){ $(obj).parents('.item').animate({opacity: 0, height:0, padding:0, margin:0}, 800, function(){ $(this).remove(); }); }
		function dc_gallery_item_change(obj)
		{
			var objs = $('.dc_gallery .form_add .more input');
			var est=false, i=0;
			while( objs[i] ) {if( $(objs[i]).val()=="" ) est=true; i++;}
			if( $(obj).val() != "" && !est ) $('.dc_gallery .form_add .more').append($('#dc_gallery_form_item').html());
		}
		</script>
EOF;
	}	
	
	/**	End gallery extended tab block */

	
    /** ----------------------------------------
    /**	Save
    /** ----------------------------------------*/

	function save_start()
	{
		global $EXT, $IN;
		
		$EXT->end_script = FALSE;
		
		// Enable for this weblog ?
		if( ! $this->conf('weblogs') || ! in_array($IN->GBL('weblog_id'), $this->conf('weblogs')) ) return;
		//print_r($_FILES);print_r($_POST); exit();
	}

    function save( $entry_id, $data, $ping_message )
	{
		global $EXT, $IN, $DB;
		
		$EXT->end_script = FALSE;
		
		// Enable for this weblog ?
		if( ! $this->conf('weblogs') || ! in_array($IN->GBL('weblog_id'), $this->conf('weblogs')) ) return;
		
		$errors = array();

		/** Upload Path */
		$path = $this->conf('upload_path');
		$path = str_replace(LD.'weblog_id'.RD, $IN->GBL('weblog_id'), $path); // {weblog_id}
		$path = str_replace(LD.'entry_id'.RD, $IN->GBL('entry_id'), $path); // {entry_id}
		$blog_name = $DB->query("SELECT `blog_name` FROM `exp_weblogs` WHERE `weblog_id`='".$IN->GBL('weblog_id')."' LIMIT 0,1");
		$path = str_replace(LD.'blog_name'.RD, $blog_name->row['blog_name'], $path); // {blog_name}
		
		/** create path structur */
		$exp_path = explode('/', str_replace("\\", '/', $path));
		$create_path = "";
		foreach( $exp_path as $dir )
		{
			$create_path .= $dir.'/';
			if( !is_dir($create_path) ) mkdir($create_path, 0777);
		}

		/** Sortable */
		if( $sortable = $IN->GBL('dc_galley_sort', 'POST') )
		{
			foreach( $sortable as $cat_id=>$sort )
				foreach( $sort as $order=>$img_id )
				{
					$DB->query("UPDATE `exp_dc_gallery` SET `cat_id`='$cat_id', `order`='".($order+1)."' WHERE `image_id`='$img_id'");
				}
		}
		
		/** Delete images */
		if( $IN->GBL('dc_gallery_delete', 'POST') )
		{
			$imgs = $DB->query("SELECT `filename`, `filename_medium`, `filename_thumb` FROM `exp_dc_gallery` WHERE `image_id` IN ('".implode("','", $IN->GBL('dc_gallery_delete', 'POST'))."')");
			foreach( $imgs->result as $row )
			{
				if( $row['filename_thumb']!="" && file_exists($path.$row['filename_thumb']) ) @unlink($path.$row['filename_thumb']);
				if( $row['filename_medium']!="" && file_exists($path.$row['filename_medium']) ) @unlink($path.$row['filename_medium']);
				if( $row['filename']!="" && file_exists($path.$row['filename']) ) @unlink($path.$row['filename']);
			}
			$DB->query("DELETE FROM `exp_dc_gallery` WHERE `image_id` IN ('".implode("','", $IN->GBL('dc_gallery_delete', 'POST'))."')");
		}
		
		/** Include Image Library */
		require PATH_CORE.'core.image_lib'.EXT;
		$IM = new Image_lib();
		//$IM->resize_protocol = 'imagemagick';  	// Can be:  imagemagick, netpbm, gd, gd2
		
		/** Upload and resize  */
		if( isset($_FILES['dc_gallery_image']['name']) )
		foreach( $_FILES['dc_gallery_image']['name'] as $id=>$name )
		if( $name != "" && $_FILES['dc_gallery_image']['error'][$id]==0 )
		{
			$vals = $IM->get_image_properties($_FILES['dc_gallery_image']['tmp_name'][$id], TRUE);
			// if is image
			if( $vals['width'] > 1 )
			{
				$wh_param = array();
				
				// Construct SQL Query
				$sql = "INSERT INTO `exp_dc_gallery` SET `entry_id`='".$IN->GBL('entry_id')."', `weblog_id`='".$IN->GBL('weblog_id')."'";
				$cats = $IN->GBL('dc_gallery_cat', 'POST');
				if( isset($cats[$id]) && $cats[$id]!= "" ) $sql .= ",`cat_id`='".$cats[$id]."'";
				$sql .= ",`time`='".time()."'";
				
				// Upload & Resize Original foto
				if( $this->conf('orig_w') || $this->conf('orig_h') )
				{
					$new_w = $this->conf('orig_w') ? $this->conf('orig_w'): ceil($vals['width']/($vals['height']/$this->conf('orig_h')));
					$new_h = $this->conf('orig_h') ? $this->conf('orig_h'): ceil($vals['height']/($vals['width']/$this->conf('orig_w')));
					// No resize small images ?
					if( $this->conf('orig_no_resize_up') && $vals['width']<$new_w && $vals['height']<$new_h )
					{
						$new_w = $vals['width'];
						$new_h = $vals['height'];
					}
				}
				else
				{
					$new_w = $vals['width'];
					$new_h = $vals['height'];
				}
				
				$name = $this->create_name($name, $path);
				$wh_param['orig'] = array($new_w, $new_h);
				
				// Crop ?
				if( $this->conf('orig_crop') )
				{
					$new_h = ceil($vals['height']/($vals['width']/$new_w));
					if( $new_h < $this->conf('orig_h') )
					{
						$new_h = $this->conf('orig_h');
						$new_w = ceil($vals['width']/($vals['height']/$new_h));
					}
					$wh_param['orig'] = array($this->conf('orig_w'), $this->conf('orig_h'));
				}
				$res = $IM->set_properties(
									array(
										'full_src_path'		=> $_FILES['dc_gallery_image']['tmp_name'][$id],
										'full_dst_path'		=> $path.$name['full'],
										'image_type'		=> $vals['image_type'],
										'new_file_name'		=> $name['full'],
										'quality'			=> '90',
										'src_width'			=> $vals['width'],
										'src_height'		=> $vals['height'],
										'dst_width'			=> $new_w,
										'dst_height'		=> $new_h
										)
									);
				if( ! $IM->image_resize() ) foreach( $IM->error_msg as $err ) if( !in_array("<b>{$name['full']}</b>: $err", $errors) ) $errors[] = "<b>{$name['full']}</b>: $err";
				if( $this->conf('orig_crop') ) // Crop ?
				{
					$IM->full_src_path = $path.$name['full'];
					$IM->src_width = $new_w;
					$IM->src_height = $new_h;
					$IM->dst_width = $this->conf('orig_w') ? $this->conf('orig_w'): ceil($vals['width']/($vals['height']/$this->conf('orig_h')));
					$IM->dst_height = $this->conf('orig_h') ? $this->conf('orig_h'): ceil($vals['height']/($vals['width']/$this->conf('orig_w')));
					$IM->x_axis = floor(($new_w / 2) - ($this->conf('orig_w') / 2));
					if( ! $IM->image_crop() ) foreach( $IM->error_msg as $err ) if( !in_array("<b>{$name['full']}</b>: $err", $errors) ) $errors[] = "<b>{$name['full']}</b>: $err";
				}
				$sql .= ",`filename`='".$name['full']."'";
				$next_src = $path.$name['full'];
				$next_src_w = $new_w;
				$next_src_h = $new_h;
				
				// Upload & Resize Medium foto 
				if( ($this->conf('medium_w')>0 || $this->conf('medium_h')>0) && $this->conf('medium_name')!='' )
				{
					$new_name = $name['name'].$this->conf('medium_name').$name['ext'];
					$new_w = $this->conf('medium_w') ? $this->conf('medium_w'): ceil($vals['width']/($vals['height']/$this->conf('medium_h')));
					$new_h = $this->conf('medium_h') ? $this->conf('medium_h'): ceil($vals['height']/($vals['width']/$this->conf('medium_w')));
					$wh_param['medium'] = array($new_w, $new_h);
					
					// No resize small images ?
					if( $this->conf('medium_no_resize_up') && $vals['width']<$new_w && $vals['height']<$new_h )
					{
						$new_w = $vals['width'];
						$new_h = $vals['height'];
					}
					
					// Crop ?
					if( $this->conf('medium_crop') )
					{
						$new_h = ((int)$new_w) ? ceil($vals['height']/($vals['width']/(int)$new_w)) : 0;
						if( $new_h < $this->conf('medium_h') )
						{
							$new_h = $this->conf('medium_h');
							$new_w = ((int)$new_h) ? ceil($vals['width']/($vals['height']/(int)$new_h)) : 0;
						}
						$wh_param['medium'] = array($this->conf('medium_w'), $this->conf('medium_h'));
					}
					$res = $IM->set_properties(
										array(
											'full_src_path'		=> $_FILES['dc_gallery_image']['tmp_name'][$id],
											'full_dst_path'		=> $path.$new_name,
											'image_type'		=> $vals['image_type'],
											'new_file_name'		=> $new_name,
											'quality'			=> '100',
											'src_width'			=> $vals['width'],
											'src_height'		=> $vals['height'],
											'dst_width'			=> $new_w,
											'dst_height'		=> $new_h
											)
										);
					if( ! $IM->image_resize() ) foreach( $IM->error_msg as $err ) if( !in_array("<b>$new_name</b>: $err", $errors) ) $errors[] = "<b>$new_name</b>: $err";
					if( $this->conf('medium_crop') ) // Crop ?
					{
						$IM->full_src_path = $path.$new_name;
						$IM->src_width = $new_w;
						$IM->src_height = $new_h;
						$IM->dst_width = $this->conf('medium_w') ? $this->conf('medium_w'): ceil($vals['width']/($vals['height']/$this->conf('medium_h')));
						$IM->dst_height = $this->conf('medium_h') ? $this->conf('medium_h'): ceil($vals['height']/($vals['width']/$this->conf('medium_w')));
						$IM->x_axis = floor(($new_w / 2) - ($this->conf('medium_w') / 2));
						if( ! $IM->image_crop() ) foreach( $IM->error_msg as $err ) if( !in_array("<b>$new_name</b>: $err", $errors) ) $errors[] = "<b>$new_name</b>: $err";
					}
					$sql .= ",`filename_medium`='".$new_name."'";
					$next_src = $path.$new_name;
					$next_src_w = $new_w;
					$next_src_h = $new_h;
				}
				
				// Upload & Resize Thumb foto 
				if( ($this->conf('thumb_w')>0 || $this->conf('thumb_h')>0) && $this->conf('thumb_name')!='' )
				{
					$new_name = $name['name'].$this->conf('thumb_name').$name['ext'];
					$new_w = $this->conf('thumb_w') ? $this->conf('thumb_w'): ceil($vals['width']/($vals['height']/$this->conf('thumb_h')));
					$new_h = $this->conf('thumb_h') ? $this->conf('thumb_h'): ceil($vals['height']/($vals['width']/$this->conf('thumb_w')));
					$wh_param['thumb'] = array($new_w, $new_h);
					
					// No resize small images ?
					if( $this->conf('thumb_no_resize_up') && $vals['width']<$new_w && $vals['height']<$new_h )
					{
						$new_w = $vals['width'];
						$new_h = $vals['height'];
					}
					
					// Crop ?
					if( $this->conf('thumb_crop') )
					{
						$new_h = ((int)$new_w) ? ceil($vals['height']/($vals['width']/(int)$new_w)) : 0;
						if( $new_h < $this->conf('thumb_h') )
						{
							$new_h = $this->conf('thumb_h');
							$new_w = ((int)$new_h) ? ceil($vals['width']/($vals['height']/(int)$new_h)) : 0;
						}
						$wh_param['thumb'] = array($this->conf('thumb_w'), $this->conf('thumb_h'));
					}
					$res = $IM->set_properties(
										array(
											'full_src_path'		=> $_FILES['dc_gallery_image']['tmp_name'][$id],
											'full_dst_path'		=> $path.$new_name,
											'image_type'		=> $vals['image_type'],
											'new_file_name'		=> $new_name,
											'quality'			=> '80',
											'src_width'			=> $vals['width'],
											'src_height'		=> $vals['height'],
											'dst_width'			=> $new_w,
											'dst_height'		=> $new_h
											)
										);
					if( ! $IM->image_resize() ) foreach( $IM->error_msg as $err ) if( !in_array("<b>$new_name</b>: $err", $errors) ) $errors[] = "<b>$new_name</b>: $err";
					if( $this->conf('thumb_crop') ) // Crop ?
					{
						$IM->full_src_path = $path.$new_name;
						$IM->src_width = $new_w;
						$IM->src_height = $new_h;
						$IM->dst_width = $this->conf('thumb_w') ? $this->conf('thumb_w'): ceil($vals['width']/($vals['height']/$this->conf('thumb_h')));
						$IM->dst_height = $this->conf('thumb_h') ? $this->conf('thumb_h'): ceil($vals['height']/($vals['width']/$this->conf('thumb_w')));
						$IM->x_axis = floor(($new_w / 2) - ($this->conf('thumb_w') / 2));
						$IM->wm_hor_alignment = 'C';
						if( ! $IM->image_crop() ) foreach( $IM->error_msg as $err ) if( !in_array("<b>$new_name</b>: $err", $errors) ) $errors[] = "<b>$new_name</b>: $err";
					}
					$sql .= ",`filename_thumb`='".$new_name."'";
				}
				$sql .= ",`wh_param`='".serialize($wh_param)."'";
				
				@unlink($_FILES['dc_gallery_image']['tmp_name'][$id]);
				if( $errors != array() ) // Errors ?
				{
					@unlink($path.$name['full']);
					@unlink($path.$name['name'].$this->conf('medium_name').$name['ext']);
					@unlink($path.$name['name'].$this->conf('thumb_name').$name['ext']);
					$this->_fetch_error($errors);
				}
				
				$DB->query($sql);
			}
		}

		if( $errors != array() ) $this->_fetch_error($errors);
		return true;
	}
	
	/**	End save */
	
	function create_name($name, $path = '')
	{
		GLOBAL $PREFS;
		
		if( function_exists('iconv') )
		{
			$chaset = $PREFS->ini('charset')?$PREFS->ini('charset'):'utf-8';
			$name = iconv($chaset, 'cp1251', $name);
		}
		
		// EXT
		$exp_name = explode('.', $name);
		$name = '';
		for( $i=0; $i<=count($exp_name)-1; $i++ )
		{
			if( $i==count($exp_name)-1 ) $ext = '.'.$exp_name[$i];
			elseif( $i<count($exp_name)-2 ) $name .= $exp_name[$i].'.';
			else $name .= $exp_name[$i];
		}
		
		$tmp = "";
		//$name = str_replace(' ', '_', $name);
		$name = preg_replace('/[ _]+/i', '_', $name);
		$name = preg_replace('/[-]+/i', '-', $name);
		for( $i=0; $i<strlen($name); $i++ )
		{
			$c = ord($name[$i]);
			
			if( $name[$i]=='_' || $name[$i]=='-' || $name[$i]=='.' ) {$tmp .= $name[$i]; continue;}
			if( $c >= 48 && $c <= 57 ) {$tmp .= $name[$i]; continue;}	// 0, 1, 2,...
			if( $c >= 65 && $c <= 90 ) {$tmp .= $name[$i]; continue;}	// A, B, C,...
			if( $c >= 97 && $c <= 122 ) {$tmp .= $name[$i]; continue;}	// a, b, c,...
			
			if( $c == '192' ) {$tmp .= 'a'; continue;}
			if( $c == '193' ) {$tmp .= 'b'; continue;}
			if( $c == '194' ) {$tmp .= 'v'; continue;}
			if( $c == '195' ) {$tmp .= 'g'; continue;}
			if( $c == '196' ) {$tmp .= 'd'; continue;}
			if( $c == '197' ) {$tmp .= 'e'; continue;}
			if( $c == '198' ) {$tmp .= 'zh'; continue;}
			if( $c == '199' ) {$tmp .= 'z'; continue;}
			if( $c == '200' ) {$tmp .= 'i'; continue;}
			if( $c == '201' ) {$tmp .= 'j'; continue;}
			if( $c == '202' ) {$tmp .= 'k'; continue;}
			if( $c == '203' ) {$tmp .= 'l'; continue;}
			if( $c == '204' ) {$tmp .= 'm'; continue;}
			if( $c == '205' ) {$tmp .= 'n'; continue;}
			if( $c == '206' ) {$tmp .= 'o'; continue;}
			if( $c == '207' ) {$tmp .= 'p'; continue;}
			if( $c == '208' ) {$tmp .= 'r'; continue;}
			if( $c == '209' ) {$tmp .= 's'; continue;}
			if( $c == '210' ) {$tmp .= 't'; continue;}
			if( $c == '211' ) {$tmp .= 'u'; continue;}
			if( $c == '212' ) {$tmp .= 'f'; continue;}
			if( $c == '213' ) {$tmp .= 'h'; continue;}
			if( $c == '214' ) {$tmp .= 'c'; continue;}
			if( $c == '215' ) {$tmp .= 'ch'; continue;}
			if( $c == '216' ) {$tmp .= 'sh'; continue;}
			if( $c == '217' ) {$tmp .= 'sch'; continue;}
			if( $c == '219' ) {$tmp .= 'y'; continue;}			
			if( $c == '221' ) {$tmp .= 'e'; continue;}
			if( $c == '222' ) {$tmp .= 'yu'; continue;}
			if( $c == '223' ) {$tmp .= 'ya'; continue;}
			
			if( $c == '224' ) {$tmp .= 'a'; continue;}
			if( $c == '225' ) {$tmp .= 'b'; continue;}
			if( $c == '226' ) {$tmp .= 'v'; continue;}
			if( $c == '227' ) {$tmp .= 'g'; continue;}
			if( $c == '228' ) {$tmp .= 'd'; continue;}
			if( $c == '229' ) {$tmp .= 'e'; continue;}
			if( $c == '230' ) {$tmp .= 'zh'; continue;}
			if( $c == '231' ) {$tmp .= 'z'; continue;}
			if( $c == '232' ) {$tmp .= 'i'; continue;}
			if( $c == '233' ) {$tmp .= 'j'; continue;}
			if( $c == '234' ) {$tmp .= 'k'; continue;}
			if( $c == '235' ) {$tmp .= 'l'; continue;}
			if( $c == '236' ) {$tmp .= 'm'; continue;}
			if( $c == '237' ) {$tmp .= 'n'; continue;}
			if( $c == '238' ) {$tmp .= 'o'; continue;}
			if( $c == '239' ) {$tmp .= 'p'; continue;}
			if( $c == '240' ) {$tmp .= 'r'; continue;}
			if( $c == '241' ) {$tmp .= 's'; continue;}
			if( $c == '242' ) {$tmp .= 't'; continue;}
			if( $c == '243' ) {$tmp .= 'u'; continue;}
			if( $c == '244' ) {$tmp .= 'f'; continue;}
			if( $c == '245' ) {$tmp .= 'h'; continue;}
			if( $c == '246' ) {$tmp .= 'c'; continue;}
			if( $c == '247' ) {$tmp .= 'ch'; continue;}
			if( $c == '248' ) {$tmp .= 'sh'; continue;}
			if( $c == '249' ) {$tmp .= 'sch'; continue;}
			if( $c == '251' ) {$tmp .= 'y'; continue;}
			if( $c == '253' ) {$tmp .= 'e'; continue;}
			if( $c == '254' ) {$tmp .= 'yu'; continue;}
			if( $c == '255' ) {$tmp .= 'ya'; continue;}
		}
		$name = $tmp;
		
		if( $name == '' ) $error = true;
		
		// Unique
		if( $path != '' )
		{
			$unique = FALSE; $i = 1;
			if( file_exists($path.$name.$ext) )
			{
				while( !($unique == TRUE || $i>50) )
				{
					if( ! file_exists($path.$name.$i.$ext) )
					{
						$name .= $i; 
						$unique = true;
					}
					$i++;
				}
				if( $unique == FALSE ) $name = md5($name.time());
			}
		}
		
		return array('name'=>$name,'ext'=>$ext,'full'=>$name.$ext);
	}

	// ----------------------------------------
    //	Fetch error
    // ----------------------------------------

    function _fetch_error( $error )
    {
    	global $OUT;

        $content  = '<ul>';

        if ( ! is_array($error))
        {
			$content	.= "<li>".$error."</li>\n";
        }
		else
		{
			foreach ($error as $val)
			{
				$content	.= "<li>".$val."</li>\n";
			}
        }

        $content .= "</ul>";

		return $OUT->show_user_error('general', $error);
    }

    //	End fetch error

/*
    // ----------------------------------------
    //	Fetch template
    // ----------------------------------------

    function _fetch_template( $tmp = '', $data = array(), $settings = array() )
    {
    	global $DB, $LANG, $OUT, $REGX;

		if ( $tmp == '' )
		{
			return FALSE;
		}

		$template = explode("/", $tmp);

		$query		= $DB->query("SELECT t.template_type, t.template_data FROM exp_templates AS t LEFT JOIN exp_template_groups AS tg ON tg.group_id = t.group_id WHERE tg.group_name = '".$template['0']."' AND t.template_name = '".$template['1']."' LIMIT 1" );

		if ( $query->num_rows == 0 )
		{
			return FALSE;
		}

		// ----------------------------------------
		//  Prevent an infinite loop if this
		//	function is being called inside the
		//	template that we are calling.
		// ----------------------------------------

		if ( stristr( $query->row['template_data'], "exp:cheers" ) )
		{
			return $OUT->show_user_error('general', array($LANG->line('template_loop')));
		}

		// ----------------------------------------
		//  Instantiate template class
		// ----------------------------------------

		if ( ! class_exists('Template'))
		{
			require PATH_CORE.'core.template'.EXT;
		}

		global $TMPL;

		$TMPL = new Template();

		// ----------------------------------------
		//  Set some values
		// ----------------------------------------

		$TMPL->encode_email	= FALSE;

		$TMPL->global_vars	= array_merge( $TMPL->global_vars, $data );

		$TMPL->run_template_engine( $template['0'], $template['1'] );

		// ----------------------------------------
		//  Parse typography
		// ----------------------------------------

		if ( ! class_exists('Typography'))
		{
			require PATH_CORE.'core.typography'.EXT;
		}

		$TYPE					= new Typography(0);
		$TYPE->smileys			= FALSE;
		$TYPE->highlight_code	= TRUE;

		$body = $TYPE->parse_type(
								stripslashes(
											$REGX->xss_clean( $TMPL->final_template )
											),
										   array(
												'text_format'   => ( isset( $settings['parse'] ) ) ? $settings['parse']: 'xhtml',
												'html_format'   => ( isset( $settings['html'] ) ) ? $settings['html']: 'all',
												'auto_links'   => ( isset( $settings['auto_links'] ) ) ? $settings['auto_links']: 'n',
												'allow_img_url'   => ( isset( $settings['allow_img_url'] ) ) ? $settings['allow_img_url']: 'y'
												 )
								);

		// ----------------------------------------
		//  Return
		// ----------------------------------------

		return $body;
	}

	//	End fetch template
*/
}

/**	End class */
?>