<?php
/*
=====================================================
	ExpressionEngine - by Denik
-----------------------------------------------------
	http://denik.od.ua/
-----------------------------------------------------
	Copyright (c) 2008 - 2009 Denik, Inc.
-----------------------------------------------------
	Version:		1.0
-----------------------------------------------------
	Compatibility:	EE 1.6.7
-----------------------------------------------------
	Updated:		2010-04-03
=====================================================
File: mod.dc_gallery.php
=====================================================
*/

if ( ! defined('EXT'))
{
    exit('Invalid file request');
}

class Dc_gallery {
	
	var $conf = array();
	
	/**************************/
	/*  Вывод списка тестов
	/**************************/
	function images()
	{
		global $DSP, $DB, $TMPL, $SESS, $FNS, $PREFS, $IN;

		$pref = "image_";
		
		// SQL START
		$sql = "SELECT DISTINCT(g.`image_id`), g.`entry_id`, g.`filename`, g.`filename_medium`, g.`filename_thumb`, g.`wh_param`, g.`time`, g.`title`, g.`description`, g.`cat_id`, c.`cat_name`, c.`cat_url_title`, w.`weblog_id`, w.`blog_name` 
			FROM exp_dc_gallery as g LEFT JOIN exp_categories as c ON c.`cat_id`=g.`cat_id` LEFT JOIN exp_weblogs as w ON g.`weblog_id`=w.`weblog_id` ";
		$sql1 = "";
		
		if( $TMPL->fetch_param('image_id') ) $sql1 .= " AND g.`image_id`='".$TMPL->fetch_param('image_id')."'";
		if( $TMPL->fetch_param('filename') ) $sql1 .= " AND g.`filename`='".$TMPL->fetch_param('filename')."'";
		if( $TMPL->fetch_param('entry_id') ) $sql1 .= " AND g.`entry_id`='".$TMPL->fetch_param('entry_id')."'";
		if( $TMPL->fetch_param('weblog_id') ) $sql1 .= " AND g.`weblog_id`='".$TMPL->fetch_param('weblog_id')."'";
		if( $TMPL->fetch_param('title') ) $sql1 .= " AND g.`title` LIKE '%".$TMPL->fetch_param('title')."%'";
		
		// limit by category
		if( $TMPL->fetch_param('category') )
		{
			$exp_cat = explode("|", trim($TMPL->fetch_param('category')));
			if( is_numeric($exp_cat[0]) )
				$sql1 .= " AND g.`cat_id` IN('".implode("','",$exp_cat)."')";
			else
			{
				$sql1 .= " AND c.`cat_url_title` IN('".implode("','",$exp_cat)."')";
			}
		}
		
		if($sql1 != "") $sql .= " WHERE ".substr($sql1, 4);
		
		// ORDER
		$sql .= " ORDER BY c.`cat_name` ASC, g.`order` ASC";
		
		$limit = $TMPL->fetch_param('limit');
		
		// Pagination
		$p_page = 0;
		if( $TMPL->fetch_param('paginate') && $limit )
		{
			$total_rows = $DB->query("SELECT count(g.`image_id`) as count FROM exp_dc_gallery as g".(($sql1 != "")?" WHERE ".substr($sql1, 4):""));
			$total_rows = $total_rows->row['count'];
			
			$page_seg = $TMPL->fetch_param('page_seg')?$TMPL->fetch_param('page_seg'):'page';
			
			$basepath = '';
			if (($IN->URI == '' OR $IN->URI == '/') && $PREFS->ini('template_group') != '' && $PREFS->ini('template') != '')
			{
				$basepath = $FNS->create_url($PREFS->ini('template_group').'/'.$PREFS->ini('template'), 1);
			}
			
			if ($basepath == '')
			{
				$basepath = $FNS->create_url($IN->URI, 1);
				
				if (preg_match("#^$page_seg(\d+)|/$page_seg(\d+)#", $basepath, $match))
				{
					$p_page = (isset($match['2'])) ? $match['2'] : $match['1'];
					$basepath = $FNS->remove_double_slashes(str_replace($match['0'], '', $basepath));
				}
			}
			
			if ( ! class_exists('Paginate'))
			{
				require PATH_CORE.'core.paginate'.EXT;
			}
			
			$PGR = new Paginate();
			
			if ( ! ereg(SELF, $basepath) AND $PREFS->ini('site_index') != '')
			{
				$basepath .= SELF.'/';
			}
																
			$first_url = (ereg("\.php/$", $basepath)) ? substr($basepath, 0, -1) : $basepath;
			
			if ($TMPL->fetch_param('paginate_base'))
			{
				$basepath = $FNS->create_url($REGX->trim_slashes($TMPL->fetch_param('paginate_base')));
			}
			
			$PGR->first_url 	= $first_url;
			$PGR->path			= $basepath;
			$PGR->prefix		= $page_seg;
			$PGR->total_count 	= $total_rows;
			$PGR->per_page		= $limit;
			$PGR->cur_page		= $p_page;

			$pagination_links = $PGR->show_links();
			
			if ($p_page > $total_rows)
			{
				$p_page = 0;
			}
			$current_page = floor(($p_page / $limit) + 1);
			$total_pages = intval(ceil($total_rows / $limit));
			
			$page_next = "";
			if ((($total_pages * $limit) - $limit) > $p_page)
			{
				$page_next = $basepath.$page_seg.($p_page + $limit).'/';
			}
			
			$page_previous = "";
			if (($p_page - $limit ) >= 0) 
			{
				$page_previous = $basepath.$page_seg.($p_page - $limit).'/';
			}
			
			if( preg_match("/".LD.$pref."paginate".RD."(.+?)".LD.SLASH.$pref."paginate".RD."/s", $TMPL->tagdata, $match) )
			{
				$TMPL->tagdata = str_replace($match[0], '', $TMPL->tagdata);
				$vars = array();
				$vars[$pref.'pagination_links'] = $pagination_links;
				$vars[$pref.'current_page'] = $current_page;
				$vars[$pref.'total_pages'] = $total_pages;
				$vars[$pref.'previous_page'] = $page_previous;
				$vars[$pref.'next_page'] = $page_next;
				$pagination = $match[1];
				foreach( $vars as $k=>$v ) $pagination = str_replace(LD.$k.RD, $v, $pagination);
				$pagination = $FNS->prep_conditionals($pagination, $vars);
			}
		}

		// LIMIT
		if( $limit ) $sql .= " LIMIT $p_page, $limit";
		
		// Run SQL
		$img = $DB->query($sql);
		
		$num_rows = $img->num_rows;
		
		// no results
		if( $img->num_rows == 0 ) return $TMPL->no_results();
		
		$res = '';
		$count = 1;
		foreach ($img->result as $val)
		{
			// Parse content
			$tmp = $TMPL->tagdata;
			$vars = array();
			
			$vars[$pref.'count'] = $count;
			$vars[$pref.'total_rows'] = isset($total_rows)?$total_rows:0;
			$vars[$pref.'num_rows'] = $num_rows;
			$vars[$pref.'title'] = $val['title'];
			$vars[$pref.'description'] = $val['description'];
			$vars[$pref.'id'] = $val['image_id'];
			$vars[$pref.'filename'] = $val['filename'];
			$vars[$pref.'filename_medium'] = $val['filename_medium'];
			$vars[$pref.'filename_thumb'] = $val['filename_thumb'];
			$vars[$pref.'time'] = $val['time'];
			$vars[$pref.'cat_id'] = $val['cat_id'];
			$vars[$pref.'cat_name'] = $val['cat_name'];
			$vars[$pref.'cat_url_title'] = $val['cat_url_title'];
			$vars[$pref.'weblog_id'] = $val['weblog_id'];
			$vars[$pref.'blog_name'] = $val['blog_name'];
			$vars[$pref.'entry_id'] = $val['entry_id'];
			
			// wh_param
			$wh_param = @unserialize($val['wh_param']);
			$vars[$pref.'width'] = isset($wh_param['orig'][0])?$wh_param['orig'][0]:0;
			$vars[$pref.'height'] = isset($wh_param['orig'][1])?$wh_param['orig'][1]:0;
			$vars[$pref.'medium_width'] = isset($wh_param['medium'][0])?$wh_param['medium'][0]:0;
			$vars[$pref.'medium_height'] = isset($wh_param['medium'][1])?$wh_param['medium'][1]:0;
			$vars[$pref.'thumb_width'] = isset($wh_param['thumb'][0])?$wh_param['thumb'][0]:0;
			$vars[$pref.'thumb_height'] = isset($wh_param['thumb'][1])?$wh_param['thumb'][1]:0;
			
			/** Upload Path&URL */
			$url = $this->conf('upload_url');
			$url = str_replace(LD.'weblog_id'.RD, $val['weblog_id'], $url); // {weblog_id}
			$url = str_replace(LD.'entry_id'.RD, $val['entry_id'], $url); // {entry_id}
			$url = str_replace(LD.'blog_name'.RD, $val['blog_name'], $url); // {blog_name}

			$path = $this->conf('upload_path');
			$path = str_replace(LD.'weblog_id'.RD, $val['weblog_id'], $path); // {weblog_id}
			$path = str_replace(LD.'entry_id'.RD, $val['entry_id'], $path); // {entry_id}
			$path = str_replace(LD.'blog_name'.RD, $val['blog_name'], $path); // {blog_name}
			
			$tmp = str_replace(LD.$pref.'upload_url'.RD, $url, $tmp);
			$tmp = str_replace(LD.$pref.'upload_path'.RD, $path, $tmp);
			
			// Original
			$tmp = str_replace(LD.$pref.'url'.RD, $url.$val['filename'], $tmp);
			$tmp = str_replace(LD.$pref.'path'.RD, $path.$val['filename'], $tmp);
			
			// Medium
			$tmp = str_replace(LD.$pref.'medium_url'.RD, $url.$val['filename_medium'], $tmp);
			$tmp = str_replace(LD.$pref.'medium_path'.RD, $path.$val['filename_medium'], $tmp);
			
			// Thumb
			$tmp = str_replace(LD.$pref.'thumb_url'.RD, $url.$val['filename_thumb'], $tmp);
			$tmp = str_replace(LD.$pref.'thumb_path'.RD, $path.$val['filename_thumb'], $tmp);
			
			foreach( $vars as $k=>$v ) $tmp = str_replace(LD.$k.RD, $v, $tmp);
			$tmp = $FNS->prep_conditionals($tmp, $vars);
			$res .= $tmp;
			$count++;
		}
		
		// no results
		if( $count == 1 ) return $TMPL->no_results();
		
		$res = ( $TMPL->fetch_param('backspace') ) ? substr($res,0,0-$TMPL->fetch_param('backspace')):$res;
		
		// Pagination top|bottom|both
		if( $TMPL->fetch_param('paginate') == 'top' ) $res = $pagination.$res;
		elseif( $TMPL->fetch_param('paginate') == 'bottom' ) $res = $res.$pagination;
		elseif( $TMPL->fetch_param('paginate') == 'both' ) $res = $pagination.$res.$pagination;
		elseif( $TMPL->fetch_param('paginate')!="" ) $res = $res.$pagination;
		
		return $res;
	}
	
	/** Configs */
	function conf($key)
	{
		GLOBAL $PREFS;
		
		// Load Configs
		if( $this->conf == array() )
		{
			GLOBAL $DB;
			$res = $DB->query("SELECT settings FROM exp_extensions WHERE class='Dc_gallery_ext' LIMIT 0,1");
			$this->conf = @unserialize($res->row['settings']);
			$this->conf = isset($this->conf[$PREFS->ini('site_id')]) ? $this->conf[$PREFS->ini('site_id')] : array();
		}
		return isset($this->conf[$key])?$this->conf[$key]:false;
	}
}
?>